/*
 * Balancujicirobot.c
 *
 * Created: 7.5.2013 17:59:45
 *  Author: Dymy
 */ 


#include <avr/io.h>
#define F_CPU 8000000
#include <math.h>
#include <util/delay.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

// define PID regulator 
#define D 9235
#define P 897800

// define SPI
#define MISO PB4
#define MOSI PB3
#define SCK PB5
#define SS PB2
#define CSG PC1
#define CSA PC0
#define DEN_G PC3

//define inemo
#define  CSA_disable PORTC=(PORTC|(1<<CSA));
#define  CSA_enable PORTC=(PORTC&~(1<<CSA));
#define  CSG_disable PORTC=(PORTC|(1<<CSG))&~(1<<DEN_G);
#define  CSG_enable PORTC=(PORTC&~(1<<CSG))|(1<<DEN_G);
#define CTRL_REG1 0x20
#define CTRL_REG2 0x21
#define CTRL_REG3 0x22
#define CTRL_REG4 0x23
#define CTRL_REG5 0x24
#define CTRL_REG6 0x25
#define STATUS_REG 0x27
#define OUT_X_L 0x28
#define OUT_X_H 0x29
#define OUT_Y_L 0x2A
#define OUT_Y_H 0x2B
#define OUT_Z_L 0x2C
#define OUT_Z_H 0x2D

#define pozicf 5
double fa[pozicf];
double offsetgyr=0;
double offsetakc=0;
char kposlani[40];
double uhela=0,uhelg=0,uhlovarychlost=0, chteny=0;
double xd;
double zasah=0;
void InitSPI();
void InitInemo();
void InitUSART();
void PosliUSART(char data);
void PosliText(char *p);
void NastavCasovac();
void Zmer();
void NastavMotory();
char SPI_protocData(char data);
void Zapis_Inemo(char co, char kam);
char Precti_Inemo(char kde);
short PrectiDataX();
short PrectiDataY();
short PrectiDataZ();

int main(void)
{
	int i=0;
	double pom=0;
	DDRB|=(1<<PB2)|(1<<PB1);//vystup casovac (PWM)
	DDRB|=(1<<PB0);//vystup L+
	DDRD|=(1<<PD7);//vystup L-
	DDRD|=(1<<PD6);//vystup P+
	DDRD|=(1<<PD5);//vystup P-
	
	InitUSART();
	InitSPI();
	InitInemo();
	NastavCasovac();
	
	//ziskej offsety pro vzprimenou polohu
	_delay_ms(4000); //cas pro postaveni robota
	
	for (i=0;i<100;i++)
	{
		Zmer();
		_delay_ms(5);
		pom=pom+uhela;
	}
	offsetakc=pom/((double)(100.0));// prumerna hodnota vzprimene polohy
	
	//smycka
	while(1)
	{
		Zmer();
		NastavMotory();
		//sprintf(kposlani,"%d; %d; %d; %d\n\r",(int)uhlovarychlost,(int)(uhela*100),(int)(uhelg*100),(int)(zasah));
		//PosliText(kposlani);
		_delay_ms(10);
	}
}

//////////////////////////////////////////////////////////////////////////
//zmereni a vypocet jednotlivych uhlu
void Zmer()
{
	int x,i;
	int ind=0;
	int uhlovarychlosti=0;
	CSG_enable
	while((uhlovarychlosti=PrectiDataX())==0);
	CSG_disable
	uhlovarychlost=uhlovarychlosti-offsetgyr;
	//vypocet uhlu z gyra
	uhelg=uhelg+uhlovarychlost*0.05;
	_delay_ms(5);
	
	while(ind<pozicf){
		x=0;
		CSA_enable
		while((x=PrectiDataZ())==0);
		CSA_disable
		xd=x;
		fa[ind]=acos((xd-32768)/32768);
		ind++;
		}
		uhela=0;
		for (i=0;i<pozicf;i++)
		{
			uhela+=fa[i];
		}
		uhela = (uhela/pozicf)-offsetakc;
		_delay_ms(5);
	
}
//////////////////////////////////////////////////////////////////////////
//inicializace SPI
void InitSPI()
{
	DDRB|=(1<<MOSI)|(1<<SS)|(1<<SCK);// vstupn piny
	SPCR=((0<<SPIE)  //povolen interupt
	|(1<<SPE)	//povolen SPI
	|(0<<DORD)  //poad dat 1= LastSignFirst
	|(1<<MSTR) //master slave  1=Master
	|(1<<CPOL)  //polarita hodin 1=sou v high kdyz netikaj
	|(1<<CPHA) // fze hodin data sou platn na padajc v 1
	|(1<<SPR1) // peddlika zaklad je fosc/4
	|(0<<SPR0)); //pedlika
	
	SPSR|=(0<<SPI2X);  //zdvojnasoben rychlosti penosu
}
//////////////////////////////////////////////////////////////////////////
//inicializace Nastaven senzoru
void InitInemo()
{
	DDRC|=(1<<CSA)||(1<<CSG)||(1<<DEN_G);
	CSA_disable;
	CSG_disable;
	_delay_ms(100);
	CSA_enable
	Zapis_Inemo(0b01110111,CTRL_REG1);
	CSA_disable
	_delay_ms(100);
	CSG_enable
	Zapis_Inemo(0b11001111,CTRL_REG1);
	CSG_disable
}
//////////////////////////////////////////////////////////////////////////
//jednoduch odesln 8b dat po SPI jako master
char SPI_protocData(char data)
{
	SPDR=data;
	while(!(SPSR & (1<<SPIF)));
	data = SPDR;
	return data;
}
//////////////////////////////////////////////////////////////////////////
//zpis dat do registru senzoru
void Zapis_Inemo(char co, char kam)
{
	SPI_protocData(kam);
	SPI_protocData(co);
}
//////////////////////////////////////////////////////////////////////////
//ten dat z registru senzoru
char Precti_Inemo(char kde)
{
	kde|=0b10000000;
	SPI_protocData(kde);
	return SPI_protocData(0x00);
}


//////////////////////////////////////////////////////////////////////////
//inicializace serive linky 9600N2
void InitUSART()
{
	DDRD|=(1<<PD1);// TXD output pin
	UBRR0L = (unsigned char)51;
	/* Enable receiver and transmitter */
	UCSR0B = (1<<RXEN0)|(1<<TXEN0);
	/* Set frame format: 8data, 2stop bit */
	UCSR0C = (1<<USBS0)|(3<<UCSZ00);
}
//////////////////////////////////////////////////////////////////////////
//posli znak pres seriovou linku
void PosliUSART(char data)
{
	while ( !( UCSR0A & (1<<UDRE0)) )	;
	UDR0 = data;
}
//////////////////////////////////////////////////////////////////////////
//nastaveni casovace pro PWM
void NastavCasovac()
{
	TCCR1A=(1<<COM1A1)|(1<<COM1B1)|(1<<WGM11);//PC PWM non-inverting + bot pro PC PWM 16b
	TCCR1B=(1<<WGM13)|(1<<CS11);// preddelicka + bit pro PC PWM 16b 
	ICR1=0xFFFF;//nastaveni maxima citani
}
//////////////////////////////////////////////////////////////////////////
// odesli string po seriove lince
void PosliText(char* text)
{
	int iii=0;
	while(text[iii]!=0)
	{
		PosliUSART(text[iii]);
		iii++;
	}
}

short PrectiDataX()
{
	short a,b;
	a = Precti_Inemo(OUT_X_L);
	b = Precti_Inemo(OUT_X_H);
	a= a|(b<<8);
	return a;
}

short PrectiDataY()
{
	short a,b;
	a = Precti_Inemo(OUT_Y_L);
	b = Precti_Inemo(OUT_Y_H);
	a= a|(b<<8);
	return a;
}

short PrectiDataZ()
{
	short a,b;
	a = Precti_Inemo(OUT_Z_L);
	b = Precti_Inemo(OUT_Z_H);
	a= a|(b<<8);
	return a;
}

//////////////////////////////////////////////////////////////////////////
//Vypocte akcni zasah nastavi na motory
void NastavMotory()
{
	zasah = uhlovarychlost*D + ((uhela-chteny)*0.9+(uhelg-chteny)*0.1)*P;
	if (zasah>65535)
	{
		zasah=65535;
	}
	else if(zasah< (-65535))
	{
		zasah=-65535;
	}
	if(zasah>0)
	{
		PORTB|=(1<<PB0);//L+ do 1
		PORTD&=~(1<<PD7);//L- do 0
		PORTD|=(1<<PD6);//P+ do 1
		PORTD&=~(1<<PD5);//P- do 0
		OCR1A=(int)zasah;// uroven PWM
		OCR1B=(int)zasah;// uroven PWM
	}
	else if(zasah<0)
	{
		zasah=-zasah;// pouze kladne hodnoty v OCR
		PORTD|=(1<<PD7);//L- do 1
		PORTB&=~(1<<PB0);//L+ do 0
		PORTD|=(1<<PD5);//P- do 1
		PORTD&=~(1<<PD6);//P+ do 0
		OCR1A=(int)zasah;// uroven PWM
		OCR1B=(int)zasah;// uroven PWM
	}
	else
	{
		PORTB&=~(1<<PB0);//L+ do 0
		PORTD&=~(1<<PD7);//L- do 0
		PORTD&=~(1<<PD6);//P+ do 0
		PORTD&=~(1<<PD5);//P- do 0
		OCR1A=0;// uroven PWM do 0
		OCR1B=0;// uroven PWM do 0
		PORTB&=~((1<<PB1)|(1<<PB2));
	}
}


